//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ClassTabForm.h"
#include "DefPropForm.h"
#include "DefMethodForm.h"
#include "Utility.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TPagesDlg *PagesDlg;
//--------------------------------------------------------------------- 
__fastcall TPagesDlg::TPagesDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//--------------------------------------------------------------------- 
void __fastcall TPagesDlg::Button1Click(TObject *Sender)
{
   if ( SaveDialog1->Execute() )
   {
      SourceFile->Text = SaveDialog1->FileName;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::Button2Click(TObject *Sender)
{
   if ( SaveDialog1->Execute() )
   {
      HeaderFile->Text = SaveDialog1->FileName;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::FormCreate(TObject *Sender)
{
    Table1->Active = true;
    Table2->Active = true;
    Table3->Active = true;    
	//   
    Table1->First();
    while ( !Table1->Eof )
    {
        ComboBox1->Items->Add(
            Table1->FieldValues["CLASSNAME"]
        );
        Table1->Next();
    }
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::ComboBox1Change(TObject *Sender)
{
	//    
	Table1->Filter = "CLASSNAME = '" + ComboBox1->Text + "'";
	Table1->Filtered = true;

	//    
	Table1->Last();

	//   
	AnsiString strClassId = Table1->FieldValues["ClassID"];
	Table1->Filtered = false;

	//  
	Table2->Filter = "CLASSID = '" + strClassId + "'";
	Table2->Filtered = true;
	Table2->First();
	ListBox1->Clear();

	while ( !Table2->Eof )
	{
		ListBox1->Items->Add( Table2->FieldValues["Method"] );
		Table2->Next();
	}

	//  
	Table3->Filter = "CLASSID = '" + strClassId + "'";
	Table3->Filtered = true;
	Table3->First();
	ListBox3->Clear();

	while ( !Table3->Eof )
	{
		ListBox3->Items->Add( Table3->FieldValues["PropertyNa"] );
		Table3->Next();
	}
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::Button3Click(TObject *Sender)
{
   //  -    
   if ( ListBox1->ItemIndex != -1 )
   {
      ListBox2->Items->Add( ListBox1->Items->Strings[ListBox1->ItemIndex] );
      ListBox1->Items->Delete( ListBox1->ItemIndex );
   }
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::Button4Click(TObject *Sender)
{
   //  -    
   if ( ListBox2->ItemIndex != -1 )
   {
      ListBox1->Items->Add( ListBox2->Items->Strings[ListBox2->ItemIndex] );
      ListBox2->Items->Delete( ListBox2->ItemIndex );
   }   
   
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::Button8Click(TObject *Sender)
{
    if ( Form1->ShowModal() )
    {
       AnsiString s = Form1->PropertyType->Text;
       s += " ";
       s += Form1->PropertyName->Text;
       ListBox4->Items->Add( s );
    }
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::Button6Click(TObject *Sender)
{
   //  -    
   if ( ListBox3->ItemIndex != -1 )
   {
      ListBox4->Items->Add( ListBox3->Items->Strings[ListBox3->ItemIndex] );
      ListBox3->Items->Delete( ListBox3->ItemIndex );
   }   
}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::Button7Click(TObject *Sender)
{
   	//  -    
   if ( ListBox4->ItemIndex != -1 )
   {
      ListBox3->Items->Add( ListBox4->Items->Strings[ListBox4->ItemIndex] );
      ListBox4->Items->Delete( ListBox4->ItemIndex );
   }


}
//---------------------------------------------------------------------------
void __fastcall TPagesDlg::Button5Click(TObject *Sender)
{
	if ( Form2->ShowModal() )
	{
		//   
		AnsiString s = Form2->MethodReturn->Text;
		s += " ";
		s += Form2->MethodName->Text;
		s += "( ";

		// 
		boolean bFlag = false;

		for ( int i=1; i<Form2->StringGrid1->RowCount; ++i )
		{
			AnsiString strArg = "";

			//       
			if ( Form2->StringGrid1->Cells[1][i].Length() )
			{
				if ( bFlag )
					s += ", ";
				strArg += Form2->StringGrid1->Cells[1][i];
				strArg += " ";
				strArg += Form2->StringGrid1->Cells[2][i];
				s += strArg;
				bFlag = true;
			}
		}
		s += ");";

		//   
		ListBox2->Items->Add( s );
	}
}
void TPagesDlg::GenerateMemberVariables(FILE *fp)
{
	//  ,     
	//      
	for ( int i=0; i<ListBox4->Items->Count; ++i )
	{
		AnsiString s = ListBox4->Items->Strings[i];
		if ( strchr( s.c_str(), ' ') )
		{
			char szProp[ 256 ];
			char szType[ 256 ];

			//    
			s += " ";

			int nPos = GetWordQuoted( s.c_str(), szType, NULL);
			GetWordQuoted( s.c_str()+nPos, szProp, NULL);

			//     
			fprintf(fp, "    %s F%s;\n",
				szType,
				szProp );

		}
	}
}

void TPagesDlg::GenerateProperties(FILE *fp)
{
	//  ,     
	for ( int i=0; i<ListBox4->Items->Count; ++i )
	{
		AnsiString s = ListBox4->Items->Strings[i];
		if ( strchr( s.c_str(), ' ') )
		{
			char szString[ 256 ];
			char szProp[ 256 ];
			char szType[ 256 ];
			strcpy ( szString, s.c_str() );

			// So we can find the end of the string.
			strcat ( szString, " " );

			int nPos = GetWordQuoted( szString, szType, NULL);
			GetWordQuoted( szString+nPos, szProp, NULL);

			fprintf(fp, "    __property %s %s={read=F%s, write=F%s};\n",
			szType,
			szProp,
			szProp,
			szProp );

		}
		else
			fprintf(fp, "    __property %s;\n", s.c_str());
	}
}

void TPagesDlg::GenerateMethodsSource(FILE *fp)
{
   for ( int i=0; i<ListBox2->Items->Count; ++i )
   {
     AnsiString s = ListBox2->Items->Strings[i];
     char szString[ 256 ];
     char szType[ 256 ];
     strcpy ( szString, s.c_str() );
     int nPos = GetWordQuoted( szString, szType, NULL);
     
     //    
     szString[strlen(szString)-1] = 0;
     
     fprintf(fp, "%s %s::%s\n",
         szType,
         ClassName->Text.c_str(),
         szString+nPos );
     fprintf(fp, "{\n}\n");
   }
}
void TPagesDlg::GenerateHeaderFile(FILE *fp)
{
   fprintf(fp,"//---------------------------------------------------------------------------\n");
   fprintf(fp,"#ifndef %sH\n", ClassName->Text.c_str() );
   fprintf(fp,"#define %sH\n", ClassName->Text.c_str() );
   fprintf(fp,"//---------------------------------------------------------------------------\n");
   fprintf(fp,"#include <vcl\SysUtils.hpp>\n");
   fprintf(fp,"#include <vcl\Controls.hpp>\n");
   fprintf(fp,"#include <vcl\Classes.hpp>\n");
   fprintf(fp,"#include <vcl\Forms.hpp>\n");
   fprintf(fp,"//---------------------------------------------------------------------------\n");
   fprintf(fp,"class %s : public %s\n", 
      ClassName->Text.c_str(),
      ComboBox1->Text.c_str() );
   fprintf(fp,"{\n");
   fprintf(fp,"private:\n");
   GenerateMemberVariables(fp);
   fprintf(fp,"protected:\n");
   fprintf(fp,"public:\n");
   for ( int i=0; i<ListBox2->Items->Count; ++i )
   {
      fprintf(fp, "    %s\n",
          ListBox2->Items->Strings[i].c_str() );
   }
   fprintf(fp,"__published:\n");
   GenerateProperties(fp);
   fprintf(fp,"};\n");
   fprintf(fp,"//---------------------------------------------------------------------------\n");
   fprintf(fp,"#endif\n");
}
void TPagesDlg::GenerateSourceFile(FILE *fp)
{
   fprintf(fp,"//---------------------------------------------------------------------------\n");
   fprintf(fp,"#include <vcl\\vcl.h>\n");
   fprintf(fp,"#pragma hdrstop\n\n");
   fprintf(fp,"#include \"%s\"\n", HeaderFile->Text.c_str());
   fprintf(fp,"//---------------------------------------------------------------------------\n");
   fprintf(fp,"static inline %s *ValidCtrCheck()\n",
       ClassName->Text.c_str());
   fprintf(fp,"{\n");
   fprintf(fp,"   return new %s(NULL);\n", 
       ClassName->Text.c_str());
   fprintf(fp,"}\n");
   fprintf(fp, "//---------------------------------------------------------------------------\n");
   fprintf(fp, "__fastcall %s::%s(TComponent* Owner)\n",
      ClassName->Text.c_str(),
      ClassName->Text.c_str());
   fprintf(fp,"   : %s(Owner)\n",
      ComboBox1->Text.c_str());
   fprintf(fp,"{\n");
   fprintf(fp,"}\n");
   GenerateMethodsSource(fp);
}

//---------------------------------------------------------------------------
void __fastcall TPagesDlg::OKBtnClick(TObject *Sender)
{
	//     
	if ( ClassName->Text.Length() == 0 )
	{
		MessageBox(NULL, "   ! ",
											"Error", MB_OK );
		return;
	}
	if ( SourceFile->Text.Length() == 0 )
	{
		MessageBox(NULL, "  	  !", "Error", MB_OK );
		return;
	}
	if ( HeaderFile->Text.Length() == 0 )
	{
		MessageBox(NULL, "     !", "Error", MB_OK );
		return;
	}

	//    
	FILE *fp = fopen(HeaderFile->Text.c_str(), "w");
	if ( fp == NULL )
	{
		MessageBox(NULL, "     ! ", "Error", MB_OK );
		return;
	}
	GenerateHeaderFile(fp);
	fclose(fp);
	FILE *sfp = fopen(SourceFile->Text.c_str(), "w");
	if ( sfp == NULL )
	{
		MessageBox(NULL, "     !",
											"Error", MB_OK );
		return;
	}

	GenerateSourceFile(sfp);
	fclose(sfp);
}
//---------------------------------------------------------------------------
