//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Utility.h"
//---------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

int GetWordQuoted ( char *string, char *word, char *brkChar )
{
   //   

   int nEndPos = 0;
   for ( int i=0; i<(int)strlen(string); ++i )
      if ( !isspace(string[i]) && (string[i] != ',' && string[i] != '|') )
      {
         nEndPos = i;
         break;
      }


   //   

   char term_char = 0;
   if ( string[nEndPos] == '"' && string[nEndPos-1] != '\\' ) {
      term_char = '"';
      nEndPos++;
   }

   int nWordPos = 0;
   for ( int j=nEndPos; j<(int)strlen(string); ++j ) {
      if ( term_char ) {
         if ( string[j] == term_char ) {
            word[j-nEndPos] = 0;
            j++;
            nWordPos = j;
            break;
         }
      }
      else
         if ( isspace(string[j]) || string[j] == ',' || string[j] == '|' )
         {
            nWordPos = j;
            break;
         }
      word[j-nEndPos] = string[j];
	   nWordPos = j;
   }

   word[nWordPos-nEndPos] = 0;
   if ( brkChar )
      *brkChar = string[nWordPos];
   if ( string[nWordPos] == ',' || string[nWordPos] == '|' )
      nWordPos++;

   return nWordPos;
}

int IsEndOfLine( char ch )
{
   if ( ch == ';' )
      return 1;
   if ( ch == '{' )
      return 1;
   if ( ch == '}' )
      return 1;
   return 0;
}

BOOL CheckClass( char *strLine, char *strClassName )
{
   char szWord[ 256 ];

   int nPos = GetWordQuoted ( strLine, szWord, NULL );
   if ( !strcmp(szWord, "typedef") || !strcmp(szWord, "extern") )
      return false;

   if ( !strcmp(szWord, "class") && strLine[strlen(strLine)-1] != ';')
   {
      nPos += GetWordQuoted ( strLine+nPos, szWord, NULL );
      // Skip declspecs
      if ( !strncmp(szWord, "__declspec", 10) )
		   GetWordQuoted ( strLine+nPos, szWord, NULL );

      strcpy( strClassName, szWord );
      return true;

   }

   return false;
}

int SkipToEndOfComment(FILE *fp)
{
  int c = 0;
  int last_c = 0;

  do {
     c = fgetc(fp);
     if ( c == '/' && last_c == '*' )
        break;
     if ( c == EOF )
        break;
     last_c = c;
  } while ( !feof(fp) );

  // ,    
  if ( !feof(fp) )
     c = fgetc(fp);
  return c;
}

BOOL PreScanClasses(char *strFileName, TListBox *pListBox)
{
   FILE *fp = fopen(strFileName, "r");
   if ( fp == NULL )
   {
      return false;
   }

   char szBuffer[ 1024 ];
   char szClassName[ 256 ];
   int  brace_cnt = 0;

   while ( !feof(fp) )
   {
       int c = 0;
       int  pos = 0;

  	   //   
       memset ( szBuffer, 0, 1024 );

       int last_c = 0;

       do {
          c = fgetc(fp);
	       if ( c == '{' )
             brace_cnt ++;
  	       if ( c == '}' )
             brace_cnt ++;
          if ( c == '#' && pos == 0 )
 	          break;
  	       if ( c == '/' && last_c == '/' )
             break;
	       if ( c == EOF )
	          break;
          if ( c == '*' && last_c == '/' )
          {
	          last_c = 0;
	          pos --; //     
              c = SkipToEndOfComment(fp);
  	       }

          // ,     

          if ( c != '\n' )
             if ( pos || !isspace(c) )
	        szBuffer[pos++] = c;

          last_c = c;
       } while ( !IsEndOfLine(c) );

       if ( (c == '#' && pos == 0) || (c == '/' && last_c == '/') )
       {
	       while ( c != '\n' && !feof(fp) )
	          c = fgetc(fp);
       }
       else
          if ( brace_cnt )
	       {
             if ( CheckClass(szBuffer, szClassName ) )
                pListBox->Items->Add( szClassName );
 	       }
   }
   fclose(fp);
}

BOOL ProcessLine( BOOL bDisplay, char *strLine, char *szClassName, TListBox *pPropList,
   TListBox *pMethodList )
{
   char szWord[ 256 ];

   int nPos = GetWordQuoted ( strLine, szWord, NULL );
   if ( !strcmp(szWord, "typedef") || !strcmp(szWord, "extern") )
      return bDisplay;

   if ( !strcmp(szWord, "class") && strLine[strlen(strLine)-1] != ';')
	   {
      nPos += GetWordQuoted ( strLine+nPos, szWord, NULL );
      // Skip declspecs
      if ( !strncmp(szWord, "__declspec", 10) )
	      nPos += GetWordQuoted ( strLine+nPos, szWord, NULL );

      if ( !strcmp(szWord, szClassName) )
         return true;
      else
         return false;
   }

   	//        
	//    
	if ( bDisplay == false )
		return false;

	//  

   if ( !strcmp(szWord, "__property") )
   {
      char szType[ 256 ];
      char szPropName[ 256 ];
      nPos += GetWordQuoted ( strLine+nPos, szType, NULL );
      nPos += GetWordQuoted ( strLine+nPos, szPropName, NULL );
      if ( !strcmp(szPropName, "*") || !strcmp(szPropName, "&") )
      {
         strcat( szType, szPropName );
	 nPos += GetWordQuoted ( strLine+nPos, szPropName, NULL );
      }

      //     
      if ( strlen(szPropName) && strcmp(szPropName, ";") && strcmp(szPropName, "=") )
    	    pPropList->Items->Add(szPropName);
      else
          pPropList->Items->Add(szType);
   }
   else
      if ( strstr(strLine, "__fastcall") )
      {
         pMethodList->Items->Add(strLine);
      }

      return true;
}

void GetMethodsAndProperties(char *fileName, char *className, TListBox *pPropList,
	TListBox *pMethodList )
{
   FILE *fp = fopen(fileName, "r");
   if ( fp == NULL )
   {
      return;
   }

   char szBuffer[ 1024 ];
   int  brace_cnt = 0;
   BOOL bFoundIt = FALSE;
   while ( !feof(fp) )
   {
       char c = 0;
       int  pos = 0;

       //   
       memset ( szBuffer, 0, 1024 );

       char last_c = 0;

       do {
          c = fgetc(fp);
	       if ( c == '{' )
             brace_cnt ++;
	       if ( c == '}' )
             brace_cnt ++;
          if ( c == '#' && pos == 0 )
	          break;
	       if ( c == '/' && last_c == '/' )
             break;
	       if ( c == EOF )
	          break;
          if ( c == '*' && last_c == '/' )
          {
	          last_c = 0;
	          pos --; //     
             c = SkipToEndOfComment(fp);
  	       }
          if ( c != '\n' )
             if ( pos || !isspace(c) )
	        szBuffer[pos++] = c;

	       if ( !strcmp(szBuffer, "public:") ||
	            !strcmp(szBuffer, "private:") ||
	            !strcmp(szBuffer, "protected:") )
  	       {
	          pos = 0;
             szBuffer[pos] = 0;
  	       }

          last_c = c;
       } while ( !IsEndOfLine(c) );

       if ( (c == '#' && pos == 0) || (c == '/' && last_c == '/') )
       {
	       while ( c != '\n' && !feof(fp) )
	          c = fgetc(fp);
       }
       else
          bFoundIt = ProcessLine( bFoundIt, szBuffer, className, pPropList, pMethodList );
   }
   fclose(fp);
}
